# ======= GENERAL SETTINGS: Adapt these per assignment =============
ASSIGNMENT = "Duke ECE/CS 250 Homework 3"
SEMESTER = "Fall 2017"
TEST_DIR = 'tests' # where test files are located
IS_GRADER = False # if true, we'll expect to see a 'points' parameter in test setup

SPIM_BINARY = 'spim' # location of spim executable (or just 'spim' if in path); only needed if mode is SPIM
LOGISIM_JAR = 'logisim_cli.jar' # location of logisim_cli.jar; only needed if mode is LOGISIM

# modes: 
#   EXECUTABLE - for C programs, etc.
#   SPIM       - run with command line spim
#   LOGISIM    - run with logisim command-line front-end
MODE = 'LOGISIM'

NON_ZERO_EXIT_STATUS_PENALTY = 0.75 # multiply score by this if exit status is non-zero
VALGRIND_PENALTY = 0.5 # multiply score by this if a valgrind test showed a leak

# ============= TEST SETUP ========================
suite_names = ('circuit1a', 'circuit1c', 'adder', 'fsm')
suites = {
    "circuit1a": [
        { "desc": "A=0, B=0, C=0", "args": ['-ip A=0,B=0,C=0 -c 0'] },
        { "desc": "A=0, B=0, C=1", "args": ['-ip A=0,B=0,C=1 -c 0'] },
        { "desc": "A=1, B=0, C=1", "args": ['-ip A=1,B=0,C=1 -c 0'] },
        { "desc": "A=1, B=1, C=1", "args": ['-ip A=1,B=1,C=1 -c 0'] },
    ],
    "circuit1c": [
        { "desc": "A=0, B=0, C=0", "args": ['-ip A=0,B=0,C=0 -c 0'] },
        { "desc": "A=0, B=0, C=1", "args": ['-ip A=0,B=0,C=1 -c 0'] },
        { "desc": "A=0, B=1, C=0", "args": ['-ip A=0,B=1,C=0 -c 0'] },
        { "desc": "A=1, B=0, C=0", "args": ['-ip A=1,B=0,C=0 -c 0'] },
    ],
    "adder": [
        { "desc": "A=0xABCD, B=0x5678, sub=0", "args": ['-c 0 -ip A=0xABCD,B=0x5678,sub=0 -of h'] },
        { "desc": "A=0xABCD, B=0x5678, sub=1", "args": ['-c 0 -ip A=0xABCD,B=0x5678,sub=1 -of h'] },
        { "desc": "A=0xB210, B=0xABCD, sub=0", "args": ['-c 0 -ip A=0x3210,B=0xABCD,sub=0 -of h'] },
        { "desc": "A=0xB210, B=0xABCD, sub=1", "args": ['-c 0 -ip A=0x3210,B=0xABCD,sub=1 -of h'] },
        { "desc": "A=0x9BDF, B=0x8ACE, sub=0", "args": ['-c 0 -ip A=0x9BDF,B=0x8ACE,sub=0 -of h'] },
        { "desc": "A=0x9BDF, B=0x8ACE, sub=1", "args": ['-c 0 -ip A=0x9BDF,B=0x8ACE,sub=1 -of h'] },
        { "desc": "A=0x7531, B=0x6420, sub=0", "args": ['-c 0 -ip A=0x7531,B=0x6420,sub=0 -of h'] },
        { "desc": "A=0x7531, B=0x6420, sub=1", "args": ['-c 0 -ip A=0x7531,B=0x6420,sub=1 -of h'] },
    ],
    "fsm": [
        { "desc": "constant input: in1=0,in2=0, total cycles=5", "args": ['-ip in1=0,in2=0 -c 5'] },
        { "desc": "constant input: in1=1,in2=0, total cycles=5", "args": ['-ip in1=1,in2=0 -c 5'] },
        { "desc": "variable input per cycle, total cycles=5", "args": ['-ic 1,in1=0,in2=0:2,in1=0,in2=0:3,in1=1,in2=0:4,in1=1,in2=1:5,in1=1,in2=0 -c 5'] },
    ]

}
